﻿#include "windows.h"
#include "EventManager.h"
#include <vector>

EventBase::EventBase(float duration)
: m_elapse(0.0f), m_duration(duration)
{
}

void EventBase::SetCallback(IEventFunctionImp* func)
{
	m_pFunc = func;
}

bool EventBase::IsDone()
{
    return (m_elapse > m_duration);
}

void EventBase::Stop()
{
	if(m_pFunc)
	{
		m_pFunc->Run(true);
		delete m_pFunc;
		m_pFunc = NULL;
	}

    m_elapse = 0;
	m_duration = 0;
}


std::vector<float> intvec;

void EventBase::Advance(float dt)
{
    m_elapse += dt;
}

EventManager::EventManager()
{

}

void EventManager::AddEvent(EventBase* ievent)
{
	m_events.push_back(ievent);
}

void EventManager::Update(float dt)
{
	std::list<EventBase*>::iterator it = m_events.begin();
    for(; it!= m_events.end(); )
	{
		(*it)->Advance(dt);
        if((*it)->IsDone())
		{
            (*it)->Stop();
			delete (*it);
            m_events.erase(it++);
        }
        else
            it++;
	}
}


