#include <stdio.h>
#include "event/EventManager.h"

//timeGetTime function
#include <windows.h>
#include <mmsystem.h>
#pragma comment(lib, "winmm.lib")

class App
{
public:
	App();
	~App() 
	{
		DeInit();
	}
	void Init();
	void DeInit();
	void AddEvent();
	int CallbackEvent(bool arg);
	void Update();

private:
	EventManager* m_pEventManager;
	DWORD m_msTime;
};

App::App()
: m_pEventManager(NULL), m_msTime(0)
{
	Init();
}

void App::Init()
{
	m_pEventManager = new EventManager();
	m_msTime = timeGetTime();
}

void App::DeInit()
{
	if(m_pEventManager)
	{
		delete m_pEventManager;
		m_pEventManager = NULL;
	}
}

int App::CallbackEvent(bool arg)
{
	if(arg)
		printf("%0.2f CallbackEvent by EventManager\n", m_msTime/1000.0f);
	else
		printf("%0.2f CallbackEvent by function\n", m_msTime/1000.0f);

	AddEvent();
	return 0;
}

void App::AddEvent()
{
	IEventFunctionImp* eventImp = new EventFunctionImp<App>(this, &App::CallbackEvent);
	EventBase* pEvent = new EventBase(3.0f);
	pEvent->SetCallback(eventImp);
	m_pEventManager->AddEvent(pEvent);
}

void App::Update()
{
	DWORD t = timeGetTime();
	m_pEventManager->Update((float)(t - m_msTime)/1000.0f);
	m_msTime = t;
}

void main()
{
	App app;
	app.CallbackEvent(false);

	while(1)
	{
		if (GetAsyncKeyState(VK_SPACE) & 0x8000)
			break;
		app.Update();
	}
}